﻿#include "Arduino.h"
#include "read_YYBMS.h"
uint16_t MODBUS_CalCRC(const u8 buff[], const u8 len)
{
   u8 i;
   u16 crcval = 0xffff;
   u16 temp = 0;
   for(i=0;i<len;i++)
   {
     temp = (crcval>>8)^CRCtbl[(crcval&0xFF)^buff[i]];
     crcval = temp;
   }
   return crcval;
} 
unsigned long get_Ticks(){  //运行时间，单位秒
  unsigned char sendBuff[8]={0x01,0x03,0x00,0x0A,0x00,0x02,0xE4,0x09};
  unsigned char receiveBuff[7]={0};
  unsigned char checkBuff[2]={0};
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  }  
  for(int i=0;i<8;i++){
    Serial1.write(sendBuff[i]);
    delay(2);
  }
  while(Serial1.available()==0){
    delay(2);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuff[count]=Serial1.read();
    delay(3);
    if(count==6){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuff,7);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    long high1 = receiveBuff[5]*256*256*256L;
    long high2 = receiveBuff[6]*256*256L;
    long low1 = receiveBuff[3]*256L;
    long low2 = receiveBuff[4];
    long ticksAll = high1+high2+low1+low2;
    return ticksAll;
  }
  else{
    return -1;
  }
}
//2
long get_SysVol(){ //系统总电压，单位 mv/bit
  unsigned char sendBuffVol[8]={0x01,0x03,0x00,0x0C,0x00,0x02,0x04,0x08};
  unsigned char receiveBuffVol[7]={0};
  unsigned char checkBuff[2]={0};
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  }  
  for(int i=0;i<8;i++){
    Serial1.write(sendBuffVol[i]);
    delay(2);
  }
  while(Serial1.available()<=0){
    delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuffVol[count]=Serial1.read();
    delay(3);
    if(count==6){
      count++;
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuffVol,7);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    long high1 = receiveBuffVol[5]*256*256*256L;
    long high2 = receiveBuffVol[6]*256*256L;
    long low1 = receiveBuffVol[3]*256L;
    long low2 = receiveBuffVol[4];
    long volAll = high1+high2+low1+low2;
    return volAll;
  }
  else{
    return -1;
  }
}
//3
long get_SysCurt(){  //当前系统总电流,单位 0.01A/bit
  unsigned char sendBuffCurt[8]={0x01,0x03,0x00,0x0E,0x00,0x02,0xA5,0xC8};
  char receiveBuffCurt[7]={0};
  unsigned char checkBuff[2]={0};
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  }  
  for(int i=0;i<8;i++){
    Serial1.write(sendBuffCurt[i]);
    delay(2);
  }
  while(Serial1.available()<=0){
    delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuffCurt[count]=Serial1.read();
    delay(3);
    if(count==6){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }

  long checkCRC = MODBUS_CalCRC(receiveBuffCurt,7);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    long high1 = receiveBuffCurt[5]*256*256*256L;
    long high2 = receiveBuffCurt[6]*256*256L;
    long low1 = receiveBuffCurt[3]*256;
    int low2 = receiveBuffCurt[4];
    long curtAll = high1+high2+low1+low2;
    return curtAll;
  }
  else{
    return -1;
  }
}
//4
long get_Tmp(){  //最大温度值=返回值-返回值%256,最小温度=返回值%256，1℃/bit
  unsigned char sendBuffTemp[8]={0x01,0x03,0x00,0x10,0x00,0x01,0x85,0xCF};
  unsigned char receiveBuffTemp[5]={0};
  unsigned char checkBuff[2]={0};
  long temp=-1;
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  }  
  for(int i=0;i<8;i++){
    Serial1.write(sendBuffTemp[i]);
    delay(2);
  }
  while(Serial1.available()<=0){
    delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuffTemp[count]=Serial1.read();
    delay(3);
    if(count==4){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuffTemp,5);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    temp=receiveBuffTemp[3]*256L+receiveBuffTemp[4];
    return temp;
  }
  else{
    return temp;
  }
}
//5
long get_maxVol(){  //最大电压，单位 mv
  unsigned char sendBuff[8]={0x01,0x03,0x00,0x12,0x00,0x01,0x24,0x0F};
  unsigned char receiveBuff[5]={0};
  unsigned char checkBuff[2]={0};
  long maxVol=-1;
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  } 
  for(int i=0;i<8;i++){
    Serial1.write(sendBuff[i]);
    delay(2);
  }
  while(Serial1.available()==0){
   delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuff[count]=Serial1.read();
    delay(3);
    if(count==4){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuff,5);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    maxVol=int(receiveBuff[3])*256L+int(receiveBuff[4]);
    return maxVol;
  }
  else{
    return maxVol;
  }
}
//6
long get_minVol(){  //最小电压，单位 mv
  unsigned char sendBuff[8]={0x01,0x03,0x00,0x13,0x00,0x01,0x75,0xCF};
  unsigned char receiveBuff[5]={0};
  unsigned char checkBuff[2]={0};
  long minVol=-1;
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  } 
  for(int i=0;i<8;i++){
    Serial1.write(sendBuff[i]);
    delay(2);
  }
  while(Serial1.available()==0){
    delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuff[count]=Serial1.read();
    delay(3);
    if(count==4){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuff,5);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    minVol=int(receiveBuff[3])*256L+int(receiveBuff[4]);
    return minVol;
  }
  else{
    return minVol;
  }
}
//7
long get_Soc(){  //1%/bit,单位%
  unsigned char sendBuff[8]={0x01,0x03,0x00,0x14,0x00,0x01,0xC4,0x0E};
  unsigned char receiveBuff[5]={0};
  unsigned char checkBuff[2]={0};
  long Soc=-1;
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  } 
  for(int i=0;i<8;i++){
    Serial1.write(sendBuff[i]);
    delay(2);
  }
  while(Serial1.available()==0){
    delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuff[count]=Serial1.read();
    delay(3);
    if(count==4){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuff,5);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    Soc=(int(receiveBuff[3])*256L+int(receiveBuff[4]));
    return Soc;
  }
  else{
    return Soc;
  }
}
//8
long get_Actcap(){  //1%/bit,单位%
  unsigned char sendBuff[8]={0x01,0x03,0x00,0x15,0x00,0x01,0x95,0xCE};
  unsigned char receiveBuff[5]={0};
  unsigned char checkBuff[2]={0};
  long Actcap=-1;
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  } 
  for(int i=0;i<8;i++){
    Serial1.write(sendBuff[i]);
    delay(2);
  }
  while(Serial1.available()==0){
   delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuff[count]=Serial1.read();
    delay(3);
    if(count==4){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuff,5);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    Actcap=(int(receiveBuff[3])*256L+int(receiveBuff[4]));
    return Actcap;
  }
  else{
    return Actcap;
  }
}
//9
long get_State(){  //1%/bit,单位%
  unsigned char sendBuff[8]={0x01,0x03,0x00,0x15,0x00,0x01,0x95,0xCE};
  unsigned char receiveBuff[5]={0};
  unsigned char checkBuff[2]={0};
  long State=-1;
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  } 
  for(int i=0;i<8;i++){
    Serial1.write(sendBuff[i]);
    delay(2);
  }
  while(Serial1.available()==0){
    delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuff[count]=Serial1.read();
    delay(3);
    if(count==4){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuff,5);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    State=int(receiveBuff[3])*256L+int(receiveBuff[4]);
    return State;
  }
  else{
    return State;
  }
}
//10
long get_RecycleCnt(){  //循环次数
  unsigned char sendBuff[8]={0x01,0x03,0x00,0x53,0x00,0x01,0x74,0x1B};
  unsigned char receiveBuff[5]={0};
  unsigned char checkBuff[2]={0};
  long RecycleCnt=-1;
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
    Serial.print(Serial1.read());
  } 
  for(int i=0;i<8;i++){
    Serial1.write(sendBuff[i]);
    delay(3);
  }
  while(Serial1.available()==0){
    delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuff[count]=Serial1.read();  
    delay(3);
    if(count==4){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuff,5);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    RecycleCnt=int(receiveBuff[3])*256L+int(receiveBuff[4]);
    return RecycleCnt;
  }
  else{
    return RecycleCnt;
  }
}
//11
long get_PowerValue(){  //瞬时功率(wh)
  unsigned char sendBuff[8]={0x01,0x03,0x00,0x54,0x00,0x01,0xC5,0xDA};
  unsigned char receiveBuff[5]={0};
  unsigned char checkBuff[2]={0};
  long PowerValue=-1;
  while(Serial1.available()>0){
    delay(2);
    char rest=Serial1.read();
  } 
  for(int i=0;i<8;i++){
    Serial1.write(sendBuff[i]);
    delay(3);
  }
  while(Serial1.available()==0){
    delay(3);
  }
  int count=0;
  while(Serial1.available()>0){
    receiveBuff[count]=Serial1.read();
    delay(3);
    if(count==4){
      checkBuff[0]=Serial1.read();
      delay(3);
      checkBuff[1]=Serial1.read();
      delay(3);
      break;
    }
    count++;
  }
  long checkCRC = MODBUS_CalCRC(receiveBuff,5);
  long receivedCheck = int(checkBuff[0])+(int(checkBuff[1]))*256L;
  if(checkCRC==receivedCheck){
    PowerValue=int(receiveBuff[3])*256L+int(receiveBuff[4]);
    return PowerValue;
  }
  else{
    return PowerValue;
  }
}
